<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr=96000 
ksmps=64
nchnls=2
0dbfs=1


	opcode pvshift2, 0, kkiiiiii

; our input values are:
; kpitch - pitch shift amount [.5=down octave,
; 1=noshift, 2=up octave, etc]
; kstretch - spectral shift amount [ususal range is
; .99-1.01, where 1=nostretch]
; inumbins - number of fft bins [size of tables]
; iampin - table containing amp data
; iampout - table to write modified amp data
; ifreqin - table containing freq data
; ifreqout - table to write modified freq data

kpitch, kstretch, inumbins, iampin, iampout, ifreqin, ifreqout, iEQ xin

; make sure we start with an empty table
iclear 	ftgen 0, 0, inumbins, 2, 0
	tablecopy iampout, iclear
	tablecopy ifreqout, iclear

; perform a do-while loop, cycling through the tables and shifting pitch
kcount = 0
loop:
kindex 	= kcount/kpitch


if (kindex < inumbins) then

kval 	table kindex, iampin
kamp 	table kcount, iampout
kEQ 	table kcount, iEQ
		tablew (kval+kamp)*(kEQ+0.0000001), kcount, iampout
kval 	table kindex, ifreqin
		tablew kval*kpitch, kcount, ifreqout

endif

kcount = kcount + 1
kpitch = kpitch * kstretch



if (kcount < inumbins) kgoto loop


endop



	
instr 1

kdry	invalue "dry"
kdry	port kdry, 0.01
kgain invalue "gain"
kgain	port kgain, 0.01

kwet	invalue "wet"
kwet	port kwet, 0.01
kbin  invalue "bin"
kstretch invalue "stretch"
kstretch	port kstretch, 0.01

kpitch   invalue "pitch"
kpitch	port kpitch, 0.01

kshift  invalue "shift"
klow	invalue "low"


ain1, ain2	ins

 	denorm	ain1, ain2

ain1 dcblock2 ain1
ain2 dcblock2 ain2

; get input and do pvanal

ifftsize = p4
iol = p5
iNumBins = ifftsize/2 + 1
ihop = ifftsize/iol
iwindow = ifftsize*p6


idel=iwindow/sr
aout3	delay ain1,idel 
aout4	delay ain2,idel

fsig11 pvsanal ain1, ifftsize, ihop, iwindow, p7
fsig22 pvsanal ain2, ifftsize, ihop, iwindow, p7


iampin1 ftgen 0,0,iNumBins,2,0
iampout1 ftgen 0,0,iNumBins,2,0

ifreqin1 ftgen 0,0,iNumBins,2,0
ifreqout1 ftgen 0,0,iNumBins,2,0


iampin2 ftgen 0,0,iNumBins,2,0
iampout2 ftgen 2000,0,iNumBins,2,0
ifreqin2 ftgen 0,0,iNumBins,2,0
ifreqout2 ftgen 0,0,iNumBins,2,0

iEQ	ftgen 1000,0,iNumBins,2,0

fsig1 pvshift fsig11, kshift, klow
fsig2 pvshift fsig22, kshift, klow

; export fsig to tables
kflag pvsftw fsig1, iampin1, ifreqin1
if (kflag > 0) then ; only proc when frame is ready

; pitch shift/stretch
	pvshift2	kpitch, kstretch, iNumBins, iampin1, iampout1, ifreqin1, ifreqout1,iEQ

; read modified data back to fsrc
	pvsftr fsig1, iampout1, ifreqout1

endif


; export fsig to tables
kflag2 pvsftw fsig2, iampin2, ifreqin2
if (kflag2 > 0) then ; only proc when frame is ready

; pitch shift/stretch
	pvshift2	kpitch, kstretch, iNumBins, iampin2, iampout2, ifreqin2, ifreqout2,iEQ
; read modified data back to fsrc
	pvsftr fsig2, iampout2, ifreqout2

endif



aout1 pvsynth fsig1
aout2 pvsynth fsig2


outs (aout1*kwet)+(aout3*kdry), (aout2*kwet)+(aout4*kdry)

endin	


	
	
</CsInstruments>
<CsScore>

f0 86400

e

</CsScore>
</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 943 62 200 494
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>
<MacGUI>
ioView nobackground {65535, 65535, 65535}
ioSlider {5, 5} {20, 100} 0.000000 1.000000 0.000000 slider1
ioSlider {45, 5} {20, 100} 0.000000 1.000000 0.000000 slider2
ioSlider {85, 5} {20, 100} 0.000000 1.000000 0.000000 slider3
ioSlider {125, 5} {20, 100} 0.000000 1.000000 0.000000 slider4
ioSlider {165, 5} {20, 100} 0.000000 1.000000 0.000000 slider5
</MacGUI>

