
/* This .csd replaces samples sequentially to locations
   using tables and Wa/Ra to simulate sample replacement.
   It uses a UDO for writing sequentially to the tables,
   changing the index numbers of the replaced sample
   locations.
   No Vaget or Vaset is used.
*/


<CsoundSynthesizer>
<CsOptions>

-s -d -+rtaudio=PortAudio -odac4 -W -b1024 -B16384

</CsOptions>
<CsInstruments>


sr=44100
ksmps=176400 ;length of longest sound in samples
nchnls=1

;======================
;GLOBAL VARIABLES

gitmp1    ftgen 100, 0, -176400, -10, 1
gitmp2    ftgen 101, 0, -176400, -10, 1
gitmp3    ftgen 200, 0, -176400, -10, 1

gatamb init 0

gilen1 filelen "Tambourine.wav"
gilen2 filelen "Clap0.wav"
gisamples1 init 0
gisamples2 init 0

;=======================
;UDO
opcode SampleReplace, a, kkiiii

ktemp init 0
ktemp2 init 0

kread, kwrite, itblread, itblwrite, ismplnum, ismplnum2, xin

/*
printf "kread %d\n", 1, kread
printf "kwrite %d\n", 1, kwrite
printf "itblread %d\n", 1, itblread
printf "itblwrite %d\n", 1, itblwrite
printf "ismplnum %d\n", 1, ismplnum
printf "ismplnum2 %d\n", 1, ismplnum2
*/

lab1:  
ar1 tablera itblread, kread, 0
if ktemp > 0 goto lab1
if ktemp > ismplnum goto lab2

lab2:
kwrite tablewa itblwrite, ar1, 0
if ktemp2 > ismplnum2 goto lab3
if ktemp2 > 0 goto lab2

lab3:
andx line 0, p3, gisamples1
asig table andx, itblwrite
xout asig
endop
;====================
;====================
    instr 1
;GET TAMBOURINE (8 beats, 22050 samples each beat)
;Load the eight beats into a table(100) and (101)

print gilen1
gisamples1 = gilen1 * sr
print gisamples1

andx line 0, gilen1, gisamples1
asig1 diskin "Tambourine.wav", 1, 0, 0, 4
tablew asig1, andx, 100 
tablew asig1, andx, 101
    endin

;==============
    instr 2
;GET CLAP
;table lengths need to match for wa/ra

andx line 0, gilen1, gisamples1 ;using length from above

asig2 diskin "Clap0.wav", 1, 0, 0, 4
tablew asig2, andx, 200
    endin
;=================
;=================
	instr 3
;SAMPLE REPLACEMENT 
;kread, kwrite, itblread, itblwrite, ismplnum, ismplnum2

asig SampleReplace  p4, p5, p6, p7, p5-1, (p5-1)+22050
	endin
;==================
	instr 4
;GET BEAT from orig tambourine table again

;kread, kwrite, itblread, itblwrite, ismplnum, ismplnum2

asig SampleReplace  p4, p5, p6, p7, p8, p8
	endin
;======================
;======================
	instr 5
andx line 0, gilen1, gisamples1 ;using length from above
a1 table andx, 101
gatamb= gatamb + a1
	endin

	instr 6
;fout "/opt/csound5109/JFiles/Samplereplace.wav", 2, gatamb
fout "Samplereplace.wav", 2, gatamb
	endin

</CsInstruments>
<CsScore>

/*
beat  - smplnum
beat1 - 0
beat2 - 22050
beat3 - 44100
beat4 - 66150
beat5 - 88200
beat6 - 110250
beat7 - 132300
beat8 - 154350
EOF   - 176400
*/

 
             		kread,  kwrite,     itblread, itblwrite
i1	0	3
s
i2      0       3
s
i3	0	3	0	22050		200	101
s	
i4	0	3	44099	44100	 	100	101	176400
s
i3	0	3	0	66150		200	101
s
i4	0	3	88199	88200		100	101	176400
s
i3	0	3	0	110250		200	101
s
i4	0	3	132299	132300	 	100	101	176400
s
i3	0	3	0	154350		200	101
s
i5	0	3
s
i6	0	3
e


</CsScore>
</CsoundSynthesizer>

