<CsoundSynthesizer>
<CsOptions>
-odac -Ma -b128 -B512 --midi-key=4 --midi-velocity-amp=5 -m0
</CsOptions>
<CsInstruments>

/******CHANGING THE SCALES LIVE WITH RESERVED KEYS******/

;equal-tempered scale
giScale1 	ftgen 		1, 0, -12, -2,  0
;middle tone scale
giScale2 	ftgen 		2, 0, -12, -2,  0, -34, -7, 10, -14, 3, -21, -3, -27, -10, 7, -17
;pythagorean scale
giScale3 	ftgen 		3, 0, -12, -2,  0, 14, 4, -6, 8, -2, 12, 2, 16, 6, -4, 10
		massign 	0, 1
gkey1		init		48; key1 reserved for selecting scales
gkey2		init		49; key2 reserved for selecting scales
gkey3		init		50; key3 reserved for selecting scales
gkscale	init		1; setting a start value for the scale

instr 1
;;INPUT
ikey		=		p4
if ikey == i(gkey1) || ikey == i(gkey2) || ikey == i(gkey3) then
turnoff; dont't play a note from a reserved key
endif
ivel		=		p5
kreftone	invalue	"reftone"; any midi note number
ktunfreq	invalue	"tunfreq"; any frequency for it
kscale		invalue	"scale"; select scale by menu
ireftone	=		i(kreftone)
itunfreq	=		i(ktunfreq)
iscale		=		i(kscale) + 1; menu item 0 selects function table 1 etc
;;CALCULATION
icentdiff	=		1200 * logbtwo(itunfreq / cpsmidinn(ireftone)); centdifference tuning freq to usual freq
ishift		=		12 - (ireftone % 12)
indx		=		(ikey+ishift) % 12
icent		tab_i		indx, iscale; cent deviation according to function table 
ifreqeq	=		cpsmidinn(ikey); frequency for equal tempered and usual reference (a = 440 Hz)
ifreqeqtun	=		ifreqeq * cent(icentdiff); frequency for equal tempered on actual reference (tuning frequency)
ifreqscnorm	=		ifreqeq * cent(icent); frequency regarding cent deviations but usual reference (a = 440 Hz)
ifreqsctun	=		ifreqeq * cent(icent + icentdiff); frequency with correct cent deviations in scale and tuning pitch
anote		oscils		ivel, ifreqsctun, 0
kenv		linsegr	0, .1, 1, p3-0.1, 1, .1, 0
		out		anote * kenv
;;SHOW OUTPUT
Skey		sprintf	"%d", ikey
		outvalue	"key", Skey
		outvalue	"centdiff",	 icentdiff
		outvalue	"cent", icent
		outvalue	"freqeq", ifreqeq
		outvalue	"freqscnorm", ifreqscnorm
		outvalue	"freqeqtun", ifreqeqtun
		outvalue	"freqsctun", ifreqsctun
endin

instr 100; select scale by selected Midi-keys
kstatus, kchan, key, kdata2  midiin 
gkey1		invalue	"key1"
gkey2		invalue	"key2"
gkey3		invalue	"key3"
kscale1	invalue	"scale1"
kscale2	invalue	"scale2"
kscale3	invalue	"scale3"
if kstatus == 144 then; if note on
 if key == gkey1 then
gkscale		=		kscale1
 elseif key == gkey2 then
gkscale		=		kscale2
 elseif key == gkey3 then
gkscale		=		kscale3
 endif
endif
		outvalue	"scale", gkscale - 1
endin
</CsInstruments>
<CsScore>
i 100 0 9999
e
</CsScore>
</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 762 75 510 516
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>
<MacGUI>
ioView background {43433, 43947, 32896}
ioText {333, 202} {80, 25} display 0.000000 0.00100 "key" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 60
ioText {157, 202} {174, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Key Pressed
ioText {332, 309} {80, 25} display 0.000000 0.00100 "cent" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 14.0000
ioText {-1684371923, -1632653318} {227, 25} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation
ioText {334, 235} {78, 26} display 0.000000 0.00100 "freqeq" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 261.6255
ioText {102, 233} {225, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Usual Frequency of Key
ioText {334, 338} {78, 31} display 0.000000 0.00100 "freqscnorm" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 263.7593
ioText {102, 336} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency with Cent Deviation but usual Pitch Reference
ioText {334, 435} {78, 31} display 0.000000 0.00100 "freqsctun" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 265.5508
ioText {102, 433} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency with Cent Deviation and own Reference Frequency
ioText {334, 386} {78, 31} display 0.000000 0.00100 "freqeqtun" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 263.4025
ioText {102, 384} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency without Cent Deviation but with own Reference Frequency
ioText {5, 10} {494, 155} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {56832, 36608, 52736} nobackground border INPUT
ioText {97, 172} {320, 319} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground border OUTPUT
ioText {129, 104} {107, 26} editnum 443.000000 0.000001 "tunfreq" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 443.000000
ioText {121, 46} {123, 31} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Related Pitch
ioText {141, 73} {72, 27} label 0.000000 0.00100 "" center "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder (Hertz)
ioText {-610629723, -1632653302} {80, 25} display 0.000000 0.00100 "cent" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 14.0000
ioText {-610629955, -1632653304} {227, 25} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation
ioText {102, 307} {225, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation because of Scale
ioText {333, 263} {80, 25} display 0.000000 0.00100 "centdiff" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 11.7287
ioText {105, 262} {222, 43} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder General Cent Deviation because of Tuning Reference
ioMenu {252, 107} {80, 24} 0 303 "scale1,scale2,scale3" scale
ioText {251, 46} {84, 49} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Show Scale
ioText {369, 16} {114, 50} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Select Scale by Midi Keys
ioText {362, 57} {63, 27} label 0.000000 0.00100 "" center "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Key-Nr
ioText {424, 56} {69, 28} label 0.000000 0.00100 "" center "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Scale-Nr
ioText {368, 82} {55, 25} editnum 48.000000 1.000000 "key1" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 48.000000
ioText {368, 106} {55, 25} editnum 49.000000 1.000000 "key2" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 49.000000
ioText {368, 130} {55, 25} editnum 50.000000 1.000000 "key3" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 50.000000
ioText {433, 83} {55, 25} editnum 1.000000 1.000000 "scale1" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 1.000000
ioText {433, 107} {55, 25} editnum 2.000000 1.000000 "scale2" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 2.000000
ioText {433, 131} {55, 25} editnum 3.000000 1.000000 "scale3" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 3.000000
ioText {38, 106} {68, 26} editnum 69.000000 1.000000 "reftone" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 69.000000
ioText {23, 45} {90, 47} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Reference Tone
ioText {27, 85} {87, 25} label 0.000000 0.00100 "" center "Lucida Grande" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder (Midi-Number)
</MacGUI>

